package cn.com.infosec.asn1.cmp;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.ASN1TaggedObject;
import cn.com.infosec.asn1.DERBitString;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERSequence;
import cn.com.infosec.asn1.DERTaggedObject;
import cn.com.infosec.asn1.crmf.CertId;
import cn.com.infosec.asn1.x509.AlgorithmIdentifier;

public class OOBCertHash extends ASN1Encodable {
   private AlgorithmIdentifier hashAlg;
   private CertId certId;
   private DERBitString hashVal;

   private OOBCertHash(ASN1Sequence seq) {
      int var10002 = seq.size() - 1;
      int var2 = var10002 + -1;

      for(this.hashVal = DERBitString.getInstance(seq.getObjectAt(var10002)); var2 >= 0; --var2) {
         ASN1TaggedObject var3;
         if ((var3 = (ASN1TaggedObject)seq.getObjectAt(var2)).getTagNo() == 0) {
            this.hashAlg = AlgorithmIdentifier.getInstance(var3, true);
         } else {
            this.certId = CertId.getInstance(var3, true);
         }
      }

   }

   public static OOBCertHash getInstance(Object o) {
      if (o instanceof OOBCertHash) {
         return (OOBCertHash)o;
      } else if (o instanceof ASN1Sequence) {
         return new OOBCertHash((ASN1Sequence)o);
      } else {
         throw new IllegalArgumentException("Invalid object: " + o.getClass().getName());
      }
   }

   private void addOptional(ASN1EncodableVector v, int tagNo, ASN1Encodable obj) {
      if (obj != null) {
         DERTaggedObject var4;
         var4 = new DERTaggedObject.<init>(true, tagNo, obj);
         v.add(var4);
      }

   }

   public AlgorithmIdentifier getHashAlg() {
      return this.hashAlg;
   }

   public CertId getCertId() {
      return this.certId;
   }

   public DERObject toASN1Object() {
      ASN1EncodableVector var1;
      ASN1EncodableVector var10000 = var1 = new ASN1EncodableVector;
      var1.<init>();
      this.addOptional(var1, 0, this.hashAlg);
      this.addOptional(var1, 1, this.certId);
      var10000.add(this.hashVal);
      return new DERSequence(var1);
   }
}
